var FOUND_WEATHER = "found_weather";

var IMAGE = "image";
var TEXT = "text";

var CONDITION = "condition";
var TEMPERATUREF = "temperaturef";
var TEMPERATUREC = "temperaturec";
var MAIN_IMAGE = "main_image";
var HUMID = "humidity";
var WIND = "wind";
var SUNRISE = "sunrise";
var SUNSET = "sunset";
var PRESSURE = "pressure";
var DAYPREFIX = "day";
var DAY1 = DAYPREFIX + "1";
var DAY2 = DAYPREFIX + "2";
var DAY3 = DAYPREFIX + "3";
var DAY4 = DAYPREFIX + "4";
var DAY5 = DAYPREFIX + "5";
var IMAGEPREFIX = "image";
var IMAGE1 = IMAGEPREFIX + "1";
var IMAGE2 = IMAGEPREFIX + "2";
var IMAGE3 = IMAGEPREFIX + "3";
var IMAGE4 = IMAGEPREFIX + "4";
var IMAGE5 = IMAGEPREFIX + "5";

var weather_title_array = new Array(DAY1, DAY2, DAY3, DAY4, DAY5, IMAGE1, IMAGE2, IMAGE3, IMAGE4, IMAGE5);

function removeDegree(origString)
{
    if ( origString )
        return origString.replace(new RegExp("&deg;|&#176;", "g"),"\u00B0");
    else
        return origString;
}

function getWeather(cnnWeatherURL)
{
   var local_weather = new Array();

   var weatherString = myFetchURL(cnnWeatherURL);

   local_weather[FOUND_WEATHER] = false;

   if ( weatherString )
   {
      var chunks = weatherString.split("class=\"cnnWireBoxHeader\"");

      if ( chunks && chunks.length >= 5 )
      {
         var c=0;
         // find the chunk with current conditions
         for (c=0; c<chunks.length; c++)
         {
            var f = chunks[c].indexOf("<div id=\"cnnWeatherHeader\">Current Conditions");
            if ( f > -1 ) break;
         }
         local_weather[FOUND_WEATHER] = f > -1;
         if ( local_weather[FOUND_WEATHER] )
         {
            var smaller_string = chunks[c].substring(chunks[c].indexOf("<div id=\"cnnWeatherHeader\">Current Conditions"));

            // myLog("smaller_string is [" + smaller_string + "]");

            var tempHi = "cnnTempHi\">";
            var tempLo = "cnnTempLo\">";
            var img = "<img";
            var src = "src=\"";
            var srcLength = src.length;
            var endSpan = "</span>";
            var quote = "\"";
            var bold = "<b>";
            var endBold = "</b>";
            var boldLength = bold.length;
            var endBoldLength = endBold.length;

            local_weather[TEMPERATUREF] = ""
               + removeDegree(extractText(smaller_string,
                                          smaller_string.indexOf("<div class=\"cnnWeatherTempCurrent\">"),
                                          bold, endBold + " |"))
               + "|"
               + removeDegree(extractText(smaller_string,
                                          smaller_string.indexOf("</b> | "),
                                          bold, endBold));

            // myLog("local_weather[TEMPERATUREF] is [" + local_weather[TEMPERATUREF] + "]");

            local_weather[TEMPERATUREC] = "";
            //     removeDegree(extractText(smaller_string,
            //                              smaller_string.indexOf("F</span><BR>"),
            //                              "\">", "</span>"));
            // myLog("local_weather[TEMPERATUREC] is [" + local_weather[TEMPERATUREC] + "]");

            local_weather[MAIN_IMAGE] =
               extractText(smaller_string,
                           smaller_string.indexOf("<img class=\"cnnWeatherForecastCurrent\""),
                           src, quote);

            local_weather[CONDITION] = ""
               + removeDegree(extractText(smaller_string,
                                          smaller_string.indexOf("<div class=\"cnnWeatherTempCurrent\""),
                                          ">", "</div>"))
               + " "
               + extractText(smaller_string,
                             smaller_string.indexOf("<span class=\"cnnWeatherConditionCurrent\""),
                             ">", endSpan);
            // myLog("CONDITION is [" + local_weather[CONDITION] + "]");

            local_weather[HUMID] =
               extractText(smaller_string,
                           smaller_string.indexOf("<b>Humidity: "),
                           endBold, "<br");

            // myLog("HUMID is [" + local_weather[HUMID] + "]");

            local_weather[WIND] =
               extractText(smaller_string,
                           smaller_string.indexOf("<b>Wind: "),
                           endBold, "mph") + "mph";

            // myLog("WIND is [" + local_weather[WIND] + "]");

            local_weather[SUNRISE] =
               extractText(smaller_string,
                           smaller_string.indexOf("<b>Sunrise: "),
                           endBold, "<br");

            // myLog("SUNRISE is [" + local_weather[SUNRISE] + "]");

            local_weather[SUNSET] =
               extractText(smaller_string,
                           smaller_string.indexOf("<b>Sunset: "),
                           endBold, "<br");

            // myLog("SUNSET is [" + local_weather[SUNSET] + "]");

            local_weather[PRESSURE] =
               extractText(smaller_string,
                           smaller_string.indexOf("<b>Barometer: "),
                           endBold, "Hg") + "Hg";

            // myLog("PRESSURE is [" + local_weather[PRESSURE] + "]");

            // find the chunk with tomorrow's conditions
            for (; c<chunks.length; c++)
            {
               var f = chunks[c].indexOf("<div id=\"cnnWeatherHeader\">Tomorrow");
               if ( f > -1 ) break;
            }

            var extended_day_counter = 0;

            var day = "Tomorrow : "
               + extractText(chunks[c],
                             chunks[c].indexOf("<span class=\"cnnWeatherCondition\""),
                             ">", endSpan);

            var hiTemp =
               extractText(chunks[c],
                           chunks[c].indexOf("<span class=\"cnnWeatherTemp\""),
                           ">", endSpan);

            var loTemp =
               extractText(chunks[c],
                           chunks[c].indexOf("| <span class=\"cnnWeatherTemp\""),
                           ">", endSpan);

            var imgSrc =
               extractText(chunks[c],
                           chunks[c].indexOf("<img class=\"cnnWeatherForecastLater\""),
                           src, quote);

            local_weather[DAYPREFIX + (extended_day_counter + 1)] = day + "\n"
               + " Hi " + hiTemp + " Low " + loTemp;
            local_weather[IMAGEPREFIX + (extended_day_counter + 1)] = imgSrc;

            // find the chunk with the extended forecast
            for (; c<chunks.length; c++)
            {
               var f = chunks[c].indexOf("<div id=\"cnnWeatherHeader\">Extended Forecast");
               if ( f > -1 ) break;
            }

            var smaller_string2_chunks = chunks[c].split("<td class=\"");

            for (var d = 1; d < smaller_string2_chunks.length; d++ )
            {
               extended_day_counter++;
               day =
                  extractText(smaller_string2_chunks[d], 0, "\">", "<br")
                  + " : "
                  + extractText(smaller_string2_chunks[d],
                                0,
                                "<span class=\"cnnWeatherExtForecastDate\">",
                                endSpan);
               // myLog("day is [" + day + "]");
               local_weather[DAYPREFIX + (extended_day_counter + 1)] = day + " ";
            }

            smaller_string2 =
               chunks[c].substring(chunks[c].indexOf("<td class=\"FirstDay2\">"),
                                   chunks[c].indexOf("<table class=\"tableCornerBL\""));

            smaller_string2_chunks = smaller_string2.split("<td class=\"");

            extended_day_counter = 0;

            for (var e = 1; e < smaller_string2_chunks.length; e++ )
            {
               extended_day_counter++;
               hiTemp =
                  extractText(smaller_string2_chunks[e],
                              smaller_string2_chunks[e].indexOf("<div id=\"cnnWeatherExtForecastDetails"),
                              "\">", "<span class=\"cnnVerticalBar\">|");
               // myLog("hiTemp is [" + hiTemp + "]");
               loTemp =
                  extractText(smaller_string2_chunks[e],
                              smaller_string2_chunks[e].indexOf("<span class=\"cnnVerticalBar\">|"),
                              endSpan, "<br");
               // myLog("loTemp is [" + loTemp + "]");
               imgSrc = extractText(smaller_string2_chunks[e],
                                    smaller_string2_chunks[e].indexOf(img),
                                    src, quote);
               // myLog("imgSrc is [" + imgSrc + "]");

               local_weather[DAYPREFIX + (extended_day_counter + 1)] =
                  myStripExtraWhitespace(local_weather[DAYPREFIX + (extended_day_counter + 1)])
                  + "\n"
                  + myStripExtraWhitespace(" Hi " + hiTemp + " Low " + loTemp);
               // myLog(local_weather[DAYPREFIX + extended_day_counter]);
               local_weather[IMAGEPREFIX + (extended_day_counter + 1)] = imgSrc;
            }
         }
      }
   }

   return local_weather;
}

// var weather = getWeather("http://weather.cnn.com/weather/forecast.jsp?locCode=CA76");
