var FAJR = "fajr";
var SUNRISE = "sunrise";
var ZUHR = "zuhr";
var ASR = "asr";
var ASRH = "asr_h";
var MAGHRIB = "maghrib";
var ISHA = "isha";

var DAYLENGTH = "Daylength";
var BEG_OF_NAUTICAL_TWILIGHT = "Begin of Nautical Twilight";
var BEG_OF_CIVIL_TWILIGHT = "Begin of Civil Twilight";
var FAJR_TIME = "Fajr Time";
var SUNRISE_TIME = "Sunrise Time";
var SUNSET_TIME = "Sunset Time";
var NOON_TIME = "Noon Time";
var ZUHR_TIME = "Zuhr Time";
var ASR_TIME = "Asr Time";
var ASRH_TIME = "Asr Hanafi Time";
var MAGHRIB_TIME = "Maghrib Time";
var ISHA_TIME = "Isha Time";
var MIDNIGHT_TIME = "Midnight";
var END_OF_NAUTICAL_TWILIGHT = "End of Nautical Twilight";
var END_OF_CIVIL_TWILIGHT = "End of Civil Twilight";
var MAX_HEIGHT_ANGLE = "Max. height angle";
var DECLINATION_OF_SUN = "Declination of Sun";
var SUN_ALTITUDE = "Sun Altitude";
var AZIMUTH = "Azimuth";
var SOLAR_POWER = "Solar Power";
var PTIMES_DATE = "Date";

var title_array =
    new Array(FAJR, SUNRISE, ZUHR, ASR, ASRH, MAGHRIB, ISHA);
var time_title_array =
    new Array(FAJR_TIME, SUNRISE_TIME, ZUHR_TIME, ASR_TIME, ASRH_TIME, MAGHRIB_TIME, ISHA_TIME);
var title_display_array =
    new Array( "Fajr", "Sunrise", "Zuhr", "Asr", "Asr", "Maghrib", "Isha" );

var pi = Math.PI;
var radToHours = (12 / pi);

// Function library
var timeStamp = "XX.XX.XXXX";
var Result = "location xxx";
var hs, ms = "XX";
var ydays, hh, mm, jday = 0;
var inday = false,dlstime=false;
var lat = 65.85;
var lon = 24.12;
var deg2rad = pi/180.0;
var daylen, ha=0.0;
var eqtime, cosfi, altit;
var utct, loctime = 2.0;
var nowd, utctd;
var SummerTime = 0.0;
var SunDia = 0.53;     // Sunradius degrees //
// refraction AirRefr at horizon and Refr2 up to 15 degr angle  //
// Air refraction for T=0 C and P=1000 mbar //
var AirRefr = 35.0/60.0, Refr2=0.0, Ta=0.0;
var Nousu, fo, fi, dfo, dfi, twidev, twib, twie, delta, kork, noont, powers, csha = 0.0;
var fi2, twidev2, twib2, twie2, x, theta;
var wkday = 0;
var now, hr, mn, sc;
//
//   the function below returns an angle in the range
//   0 to two pi
//
function range(x)
{
    var b = x /pi/2.0;
    var a = 2*pi * (b - Math.round(b));
    if (a < 0) a = 2*pi + a;
    return a;
}

function aika(now)
{
    var y2k = new Date(2000,0,1,0);

    hr= now.getHours();
    mn=now.getMinutes();
    sc=now.getSeconds();
    utct=now.getUTCHours();

    var yearNow = now.getYear();
    //   Get the days to J2000, daynumber Y2K-bug fixed
    //   jday = day number since Y2K
    //
    if (yearNow<1000) yearNow+= 1900;
    // Time in milliseconds at noontime
    var timeNow = now.getTime()/1000.0;

    jday = Math.round((now.getTime() - y2k.getTime())/(24*3600*1000));

    //   Find the ecliptic longitude of the Sun
    //   mean longitude of the Sun
    var L = range(280.461 * deg2rad + .9856474 * deg2rad * jday);

    //   mean anomaly of the Sun
    var g = range(357.528 * deg2rad + .9856003 * deg2rad * jday);

    //   Ecliptic longitude of the Sun
    var lambda = range(L + 1.915 * deg2rad * Math.sin(g) + 0.02 * deg2rad * Math.sin(2 * g));

    //   Obliquity of the ecliptic
    var obliq = 23.439 * deg2rad - .0000004 * deg2rad * jday;

    //   Find the RA and DEC of the Sun

    var alpha = Math.atan2(Math.cos(obliq) * Math.sin(lambda), Math.cos(lambda));
    delta = Math.asin(Math.sin(obliq) * Math.sin(lambda));
    eqtime = 1440.0 -720.0 *(L - alpha)/pi;
    if (eqtime>1440.0) eqtime-= 1440.0;
    var uusi = new Date(yearNow,0,1,12,0,0);
    var NewYear = uusi.getTime()/1000.0;
    ydays = Math.round((timeNow-NewYear)/3600/24)+1;
    SummerTime = 1.0; if ((ydays<90) || (ydays>300)) SummerTime=0.0;
    if (!dlstime) SummerTime = 0.0;
    dekl = 180*delta/pi;

    wkday =  now.getDay();

    var timeStamp = ""+yearNow +"-"+fillzero(now.getMonth()+1)+"-"+now.getDate();
    return timeStamp;
}

function makeArray(numElements)
{
    this.length = numElements
        for (count = 1; count <= numElements; count++)
            this[count] = 0;
    return (this);
}

var WkDays = new makeArray(14);
WkDays[0] = "Sunday"; WkDays[7] = "Sonntag";
WkDays[1] = "Monday"; WkDays[8] = "Montag";
WkDays[2] = "Tuesday"; WkDays[9] = "Dienstag";
WkDays[3] = "Wednesday"; WkDays[10] = "Mittwoch";
WkDays[4] = "Thursday";  WkDays[11] = "Donnerstag";
WkDays[5] = "Friday"; WkDays[12] = "Freitag";
WkDays[6] = "Saturday"; WkDays[13] = "Samstag";

var lastitem = 41;
var tzr=0.0;
var inlat = false;
var pvm = "xx-xx-xx";

function hourAngle(zenith,latitude,declination)
{
    var cosha,ha;
    cosha = Math.cos(zenith)/Math.cos(deg2rad*latitude)/Math.cos(deg2rad *declination)
        - Math.tan(deg2rad *latitude)*Math.tan(deg2rad *declination);
    if (cosha<-1.0) cosha= -1.0; // no darkness
    ha = Math.acos(cosha)/deg2rad; // Hour angle for given zenith angle [degr]
    return ha;
}

function my_getPrayerTimes(l_now, l_lat, l_long, l_timezone, l_twilight_angle)
{
   var results = new Array();
    lat = parseFloat(l_lat);
    lon = parseFloat(l_long);

   now = l_now;
   pvm =  aika(now);

   utctd = now.getUTCDay();
   nowd = now.getDay();
   tzr = hr - utct;
   if ( nowd != utctd )
   {
      var dayadj = 0;
      if ( tzr < -12 ) dayadj = 24;
      if ( tzr > 12 ) dayadj = -24;
      
      tzr = hr - utct + dayadj;
   }

   // if ( l_timezone == tzr ) we do not have daylight savings time
   // if ( l_timezone != tzr ) we have daylight savings times

    // dlstime = l_dls;
    var yearNow = now.getYear();
    if (yearNow<1000) yearNow+= 1900;

    // check legal input values //
    if ((lat < -90) || (lat > 90))
    {
        alert("The value for latitude must be between -90 and 90.");
        return;
    }

    if ((lon < -180) || (lon > 180))
    {
        alert("The value for longitude must be between -180 and 180.");
        return;
    }

    if ((tzr < -12) || (tzr > 12))
    {
        alert("The value for timezone must be between -12 and 12.");
        return;
    }

    dgmn(parseFloat(lon)+0.00001);

    // Ta=tathor.value;
    // AirRefr = 159.4/(273.0+1.0*Ta);
    dgmn(AirRefr);
    // Northern hemisphere   //
    kork=90-lat+dekl;
    // Southern hemisphere  //
    if (dekl > lat )
        kork=90+lat-dekl;
    if (kork < 15.0)
        Refr2 = 1000.0*(0.1594+0.0196*kork+kork*kork* 2.0E-05)/(1.0+0.505*kork+0.0845*kork*kork)/(273.0+1.0*Ta);
    if (kork < 15.0) kork+= Refr2;

    // Calculating the hourangle //
    dfo = 0.5*SunDia+AirRefr;
    fo = hourAngle(deg2rad*(90.0+dfo),lat,dekl);
    // Calculating the hourangle for the twilight //
    // Conversion of angle to hours and minutes //
    daylen = fo/7.5;
    if (daylen<0.01)
    {
        daylen = 0.0;
    }     // arctic winter     //
    fi = hourAngle(1.675516,lat,dekl);
    twidev = fi - fo;
    fi2 = hourAngle(1.780236,lat,dekl);
    twidev2 = fi2 - fo;
    hrmn(daylen);

    results[DAYLENGTH] = hs + ":" + ms;

    ha = 15.0*(hr-tzr-SummerTime) +0.25*(mn + eqtime) +1.0*lon -180.0;
    if (ha>360.0) ha-=360.0;
    if (ha>180.0) ha-=360.0;
    cosfi = Math.sin(deg2rad*lat)*Math.sin(deg2rad*dekl)
        +Math.cos(deg2rad*lat)*Math.cos(deg2rad*dekl)*Math.cos(deg2rad*ha);
    altit = 90.0 - Math.acos(cosfi)/deg2rad; // altitude degrees
    if (altit < 6.0) altit+= AirRefr;

    // Azimuth theta:
    x = Math.sin(deg2rad*dekl)/Math.cos(deg2rad*lat);
    x = x/Math.cos(deg2rad*altit);
    x-= Math.tan(deg2rad*lat)*Math.tan(deg2rad*altit);
    theta = Math.acos(x)/deg2rad; // morning azimuth

    loctime= hr + mn/60.0;
    utct = loctime-tzr-SummerTime;
    if (utct<0.0) utct+=24.0;
    Nousu = 12.0 + eqtime/60.0 - fo/15.0 + tzr - lon/15.0 + SummerTime;
    Lasku = 12.0 + eqtime/60.0 + fo/15.0 + tzr - lon/15.0 + SummerTime;
    // noont =  Nousu + fo/15.0;
    // hrmn(noont);
    noont = 12.0 + eqtime/60.0  + tzr - lon/15.0 + SummerTime;

    if (loctime>noont) theta = 360.0 - theta; // afternoon azimuth
    twib = Nousu - twidev/15.0; // Begin civil twilight
    twie = Lasku + twidev/15.0; // End civil twilight
    twib2 = Nousu - twidev2/15.0;   // Begin nautical twilight
    twie2 = Lasku + twidev2/15.0;   // End nautical twilight
    if (twie>25.0) twie-= 24.0;  // it may overflow with DLS
    if (twie2>25.0) twie2-= 24.0;  // it may overflow with DLS

    if (fi2 < 180.0)
    {
        hrmn(twib2);
        results[BEG_OF_NAUTICAL_TWILIGHT] = hs + ":" + ms;
    }

    if (fi < 180.0)
    {
        hrmn(twib);
        results[BEG_OF_CIVIL_TWILIGHT] = hs + ":" + ms;
    }
    else
        results[BEG_OF_CIVIL_TWILIGHT] = "There is no dark time";

    if ((daylen<23.95) && (daylen>0.05))
    {
        hrmn(Nousu);
        results[SUNRISE] = hs + ":" + ms;
        results[SUNRISE_TIME] = new Date( now.toDateString() + " " + results[SUNRISE] + ":00");
        hrmn(Lasku);
        results[SUNSET_TIME] = new Date( now.toDateString() + " " + hs + ":" + ms + ":00");
        results[MAGHRIB_TIME] = results[SUNSET_TIME];
        results[MAGHRIB] = get12HourTimeString(results[MAGHRIB_TIME]);
    }
    else if (daylen>23.9)
    {
        results[SUNRISE_TIME] = "Sun is visible all day";
        results[SUNSET_TIME] = "Sun is visible all day";
    }
    else
    {
        results[SUNRISE_TIME] = "Sun is below the horizon all day";
        results[SUNSET_TIME] = "Sun is below the horizon all day";
    }

    hrmn(twie);
    if (fi < 180.0)
        results[END_OF_CIVIL_TWILIGHT] = new Date( now.toDateString() + " " + hs + ":" + ms + ":00");
    else
        results[MIDNIGHT_TIME] = new Date( now.toDateString() + " " + hs + ":" + ms + ":00");

    if (fi2 < 180.0)
    {
        hrmn(twie2);
        results[END_OF_NAUTICAL_TWILIGHT] = new Date( now.toDateString() + " " + hs + ":" + ms + ":00");
    }

    // Solar radiation power at noon for extinction 0.9 //
    if (kork>0.0) powers = 1370.0*Math.sin(deg2rad*kork)*Math.exp(Math.log(0.9)/Math.sin(deg2rad*kork));
    else  powers = 0.0;

    dgmn(kork);
    results[MAX_HEIGHT_ANGLE] = hs + ":" + ms;
    hrmn(noont);
    results[ZUHR_TIME] = new Date( now.toDateString() + " " + hs + ":" + ms + ":00");
    results[ZUHR] = get12HourTimeString(results[ZUHR_TIME]);
    results[NOON_TIME] = results[ZUHR_TIME];
    dgmn(dekl);
    results[DECLINATION_OF_SUN] = hs + ":" + ms;
    dgmn(altit);
    results[SUN_ALTITUDE] = hs + ":" + ms;
    dgmn(theta);
    results[AZIMUTH] = hs + ":" + ms;

    // hrmn(utct);
    // tulokset = tulokset + " (UTC " + hs + ":" + ms + ')';

    // if (dlstime) tulokset = tulokset + " DLST";
    results[SOLAR_POWER] = Math.floor(powers + 0.5) + " W/m2 at noon";

    // Weekdays either in English or German
    var wd = WkDays[wkday];
    results[PTIMES_DATE] = wd + " on " + pvm + ", the "+ ydays + ". day of the year";


    // Calculation of Salat Times - technical notes
    //
    // To calculate the prayer times for a certain place we need to know the latitude (B) and
    // longitude (L) of the location and its reference longitude (R). B and L may be obtained from
    // an atlas and R may be calculated by multiplying 15 by the difference between local time and
    // GMT (i.e. 15 x Time Band).
    //
    // We also need to know two astronomical measures called the declination angle of the sun (D)
    // and the real time-mean time difference, also known as the equation of time (T).
    //
    // Declination is the angular distance between a celestial object and the celestial equator. The
    // Declination and the Right Ascension are used together to give the position of a star with
    // reference to the celestial equator and the vernal equinox respectively.
    //
    // The equation of time is a correction to be added to apparent solar time, as read on a
    // sundial, to obtain mean solar time, as commonly used. This difference is a consequence of the
    // ellipticity and tilt of the Earth's orbit, causing the irregular apparent movement of the Sun
    // across the sky.
    //
    // D and T vary according to the time of year and can be obtained accurately from The Star
    // Almanac or calculated approximately.
    //
    // Graph of Declination angle (D) versus Month
    //
    // Graph of Equation of Time(T) versus Month
    //
    // The following equations may be used to calculate the prayer times:
    //
    //  (R-L)    T
    // Z = 12+ ----- + ---                  ........1
    //   15      60
    //
    //     1        {sin(-0.8333-0.0347(H)^0.5)}-sinD.sinB
    // U= -- arccos --------------------------------------      ........2
    //    15                   cosD.cosB
    //
    //     1        -sinG-sinD.sinB
    // V= -- arccos ---------------                 ........3
    //    15          cosD.cosB
    //
    //     1        sin{arccot(1+tan(B-D)}-sinD.sinB
    // W= -- arccos --------------------------------        ........4
    //    15                 cosD.cosB
    //
    //     1        sin{arccot(2+tan(B-D)}-sinD.sinB
    // X= -- arccos --------------------------------        ........5
    //    15                 cosD.cosB
    //
    // where
    //
    // B= latitude of place
    // L= longitude of place
    // R= reference longitude (i.e. TIME BAND x 15)
    // H= height above sea level in metres
    // D= declination angle of sun from celestial equator (-ve in southern hemisphere)
    // T= equation of time
    // G= twilight angle
    //
    // Fajr = Z-V
    // Sunrise = Z-U
    // Zuhr  = Z
    // Asr1 (Shafi) = Z+W
    // Asr2 (Hanafi) = Z+X
    // Maghrib/Sunset = Z+U
    // Isha = Z+V
    //
    // The algorithms to calculate T and D are not shown here. These algorithms may be found in, for
    // example, Jean Meeus' Astronomical Algorithms. Zuhr time is calculated using equation 1. The
    // time for sunrise and sunset/ maghrib may be calculated by subtracting or adding 'U'(obtained
    // from equation 2) to the Zuhr time respectively.
    //
    // Fajr and Isha times may be calculated by subtracting or adding 'V' (obtained from equation 3)
    // to the Zuhr time respectively. The term G (twilight angle) in equation 3 is usually set to 18
    // degrees. For a location with an extreme latitude, days in summer may be so long that twilight
    // persists between sunset and the next sunrise. Under these circumstances, 'V' is undefined and
    // Fajr and Isha have to be determined using agreed principles of fiqh.
    //
    // The start of Asr time (Shafi) may be obtained by adding 'W' (obtained from equation 4) to
    // Zuhr; Asr time (Hanafi) is calculated by adding 'X' (obtained from equation 5) to Zuhr.
    //

    var B = lat;
    var rad_B = B * deg2rad;
    var L = lon;
    var rad_L = L * deg2rad;
    var R = tzr * 15;
    var D = dekl;
    var rad_D = D * deg2rad;
    var T = eqtime;
    var G = l_twilight_angle; // twilight angle
    var rad_G = G * deg2rad;

    var sind = Math.sin(rad_D) * Math.sin(rad_B);
    var cosd = Math.cos(rad_D) * Math.cos(rad_B);

    var Z = SummerTime + 12 + (R - L)/15 + T/60;
    var V = ( Math.acos ( ( -1 * Math.sin(rad_G) - sind) / cosd ) ) / 15;

    var tmpTan = Math.tan(rad_B - rad_D);
    var W = ( Math.acos ( ( Math.sin ( Math.atan( 1 / ( 1 + tmpTan ) ) ) - sind ) / cosd ) ) / 15;
    var X = ( Math.acos ( ( Math.sin ( Math.atan( 1 / ( 2 + tmpTan ) ) ) - sind ) / cosd ) ) / 15;

    hrmn(Z - V/deg2rad);
    results[FAJR] = hs + ":" + ms;
    results[FAJR_TIME] = new Date( now.toDateString() + " " + results[FAJR] + ":00");

    hrmn(Z + W/deg2rad);
    results[ASR_TIME] = new Date( now.toDateString() + " " + hs + ":" + ms + ":00");
    results[ASR] = get12HourTimeString(results[ASR_TIME]);

    hrmn(Z + X/deg2rad);
    results[ASRH_TIME] = new Date( now.toDateString() + " " + hs + ":" + ms + ":00");
    results[ASRH] = get12HourTimeString(results[ASRH_TIME]);

    hrmn(Z + V/deg2rad);
    results[ISHA_TIME] = new Date( now.toDateString() + " " + hs + ":" + ms + ":00");
    results[ISHA] = get12HourTimeString(results[ISHA_TIME]);

    return results;
}

function get12HourTimeString(datetime)
{
    if ( datetime.getHours() > 12 )
        return fillzero(datetime.getHours() % 12) + ":" + fillzero(datetime.getMinutes());
    else
        return fillzero(datetime.getHours()) + ":" + fillzero(datetime.getMinutes());
}

function fillzero(x)
{
    var s="x";
    var snull = "0";
    if (x<10) s = snull+x; else s=x;
    return s;
}

function dgmn(x)
{
    var sign = 1;
    if (x<0.0)
    {
        sign = -1;
        x = Math.abs(x);
    }
    hh = Math.round(x + 0.0002);
    mm = Math.round((x - hh)*60 + 0.0002);
    if (mm<0.0)
    {
        mm+=60;
        hh-=1;
    }
    hs =  hh; if (sign<0) hs = "-"+hh;
    ms = fillzero(mm);
}

function hrmn(x)
{
    hs="00"; ms="00";

    if (x>0.0001)
    {
        hh = Math.round(x + 0.001);
        mm = Math.round((x - hh)*60 + 0.001);
        if (mm<0.0)
        {
            mm+=60;
            hh-=1;
        }
        // normalize times to max 24 hours  //
        if (hh>24.0)
        {
            hh-= 24;
        }

        if ((hh==24)&&(mm>10))
        {
            hh-= 24;
        }
        hs = fillzero(hh);
        ms = fillzero(mm);
    }
}


function dms(x)
{
    // convert decimal fraction of degrees to minutes //
    var m,i,f;
    x = Math.abs(x);    // minutes always > 0
    i = Math.floor(x);
    f = x - i;
    m = Math.round(60.0*f);
    return m;
}

function currentPrayer(l_prayer_times, l_delays, l_times, l_asr)
{
    var current_time = new Date();
    var current_time_ms = current_time.getTime();

    for ( var c = 0; c < title_array.length; c++ )
    {
        var current_prayer;
        var just_happened = false;

       var delay = l_delays[title_array[c]];
       var specific_time = l_times[title_array[c]];
       // copy the actual time into new date object so that we can manipulate it
       var adjusted_time = new Date(l_prayer_times[time_title_array[c]].getTime());
       if ( title_array[c] == ASRH )
       {
          delay = l_delays[ASR];
          specific_time = l_times[ASR];
       }

       if ( specific_time && specific_time.length != "" )
       {
          with (new Date())
          {
             var date_str = "" + getFullYear() + "/" + getMonth() + "/" + getDate() + " ";
             adjusted_time = Date.parse(date_str + specific_time);
             if ( ! adjusted_time.getHours )
             {
                adjusted_time = new Date(adjusted_time);
             }
          }
       }
       else
       {
          if ( delay && parseInt(delay) )
          {
             adjusted_time.setMinutes(adjusted_time.getMinutes() + parseInt(delay));
          }
       }

        if ( adjusted_time.getHours() == current_time.getHours()
             && adjusted_time.getMinutes() == current_time.getMinutes() )

        {
           // set up to play athan
            just_happened = true;
        }

        if ( c < 6 )
        {
            if ( l_prayer_times[time_title_array[c]].getTime() < current_time_ms
                 && current_time_ms < l_prayer_times[ time_title_array[ c + 1 ] ].getTime() )
            {
                current_prayer = title_array[c];
            }
        }
        else
        {
            if ( l_prayer_times[time_title_array[c]].getTime() < current_time_ms )
            {
                current_prayer = title_array[c];
            }
        }

        if ( current_prayer )
        {
            var res = new Array();
            res["NAME"] = current_prayer;
            res["JUST_HAPPENED"] = just_happened;
            return res;
        }
    }

    return null;
}

