
var CITY = "city";
var HIJRI = "hijri";
var GREGORIAN = "gregorian";
var DAY = "day";
var FAJR = "fajr";
var SUNRISE = "sunrise";
var ZUHR = "zuhr";
var ASR = "asr";
var ASRH = "asr_h";
var MAGHRIB = "maghrib";
var ISHA = "isha";

var TIME_FAJR = "time_fajr";
var TIME_SUNRISE = "time_sunrise";
var TIME_ZUHR = "time_zuhr";
var TIME_ASR = "time_asr";
var TIME_ASRH = "time_asr_h";
var TIME_MAGHRIB = "time_maghrib";
var TIME_ISHA = "time_isha";

var title_array = new Array(FAJR, SUNRISE, ZUHR, ASR, ASRH, MAGHRIB, ISHA);
var time_title_array = new Array(TIME_FAJR, TIME_SUNRISE, TIME_ZUHR, TIME_ASR, TIME_ASRH, TIME_MAGHRIB, TIME_ISHA);
var title_display_array = new Array( "Fajr", "Sunrise", "Zuhr", "Asr", "(H) Asr", "Maghrib", "Isha" );

function getPrayerTimes(city,
                        state,
                        country,
                        latitude,
                        longitude,
                        timezone,
                        daylightSavings)
{

    // var prayerURLPrefix = "http://www.islamicfinder.org/prayer_service.php?country=usa&city=san_mateo&state=CA&zipcode=&latitude=37.5741&longitude=-122.3193&timezone=-8&HanfiShafi=";
    // var prayerURLPostfix = "&pmethod=5&fajrTwilight1=10&fajrTwilight2=10&ishaTwilight=10&ishaInterval=30&dhuhrInterval=1&maghribInterval=1&dayLight=1";
    var prayerURLPrefix = "http://www.islamicfinder.org/prayer_service.php?pmethod=5&ishaInterval=30"
        + "&country=" + country
        + "&city=" + city
        + "&state=" + state
        + "&latitude=" + latitude
        + "&longitude=" + longitude
        + "&timezone=" + timezone
        + "&dayLight=" + daylightSavings
        + "&HanfiShafi=";

    var shafiiURL= prayerURLPrefix + "1";
    var hanafiURL= prayerURLPrefix + "2";

    var myRegExp = new RegExp("^.+prayerDetail[^>]+>([^<]+)</a>"
                              + ".+Hcal[^>]+>([^<]+)</a>"
                              + ".+Hcal[^>]+>([^<]+)</a>"
                              + ".+<b>Day</b>.+<b>([^<]+)</b>"
                              + ".+>Fajr.+<font[^>]+>([^ <]+) +</font>"
                              + ".+>Sunrise.+<font[^>]+>([^ <]+) +</font>"
                              + ".+>Dhuhr.+<font[^>]+>([^ <]+) +</font>"
                              + ".+>Asr.+<font[^>]+>([^ <]+) +</font>"
                              + ".+>Maghrib.+<font[^>]+>([^ <]+) +</font>"
                              + ".+>Isha.+<font[^>]+>([^ <]+) +</font>"
                              + ".+$",
                              "im");

    var l_prayer_times = new Array();

    var shafiiString = myFetchURL(shafiiURL);

    var shafiiFoundArray = myRegExp.exec(myStripNewlines(shafiiString));

    if ( shafiiFoundArray )
    {
        l_prayer_times[CITY] = shafiiFoundArray[1];
        l_prayer_times[HIJRI] = shafiiFoundArray[2];
        l_prayer_times[GREGORIAN] = shafiiFoundArray[3];
        l_prayer_times[DAY] = shafiiFoundArray[4];
        l_prayer_times[FAJR] = shafiiFoundArray[5];
        l_prayer_times[SUNRISE] = shafiiFoundArray[6];
        l_prayer_times[ZUHR] = shafiiFoundArray[7];
        l_prayer_times[ASR] = shafiiFoundArray[8];
        // l_prayer_times[MAGHRIB] = shafiiFoundArray[9];
        // l_prayer_times[ISHA] = shafiiFoundArray[10];
    }
    else
    {
        myLog ("Shafii Times - no match");
    }

    var hanafiString = myFetchURL(hanafiURL);
    var hanafiFoundArray = myRegExp.exec(myStripNewlines(hanafiString));

    if ( hanafiFoundArray )
    {
        // l_prayer_times[CITY] = hanafiFoundArray[1];
        // l_prayer_times[HIJRI] = hanafiFoundArray[2];
        // l_prayer_times[GREGORIAN] = hanafiFoundArray[3];
        // l_prayer_times[DAY] = hanafiFoundArray[4];
        // l_prayer_times[FAJR] = hanafiFoundArray[5];
        // l_prayer_times[SUNRISE] = hanafiFoundArray[6];
        // l_prayer_times[ZUHR] = hanafiFoundArray[7];
        l_prayer_times[ASRH] = hanafiFoundArray[8];
        l_prayer_times[MAGHRIB] = hanafiFoundArray[9];
        l_prayer_times[ISHA] = hanafiFoundArray[10];
    }
    else
    {
        myLog ("Hanafi Times - no match");
    }

    for ( var c = 0; c < title_array.length; c++ )
    {
        l_prayer_times[time_title_array[c]] = new Date(l_prayer_times[GREGORIAN] + " "
                                                       + l_prayer_times[title_array[c]] + ":00");

        if ( title_array[c] != FAJR && title_array[c] != SUNRISE )
        {
            var limit = 12;
            if ( title_array[c] == ZUHR ) limit = 11;

            if ( l_prayer_times[time_title_array[c]].getHours() < 11 )
            {
                l_prayer_times[time_title_array[c]].setHours(l_prayer_times[time_title_array[c]].getHours() + 12);
            }

        }

        myLog(title_array[c] + " " + l_prayer_times[time_title_array[c]]);
    }

    return l_prayer_times;
}

function currentPrayer(l_prayer_times)
{
    var current_time = new Date();
    var current_time_ms = current_time.getTime();

    for ( var c = 0; c < title_array.length; c++ )
    {
        var current_prayer;
        var just_happened = false;

        if ( l_prayer_times[time_title_array[c]].getHours() == current_time.getHours()
             && l_prayer_times[time_title_array[c]].getMinutes() == current_time.getMinutes() )

        {
            just_happened = true;
        }

        if ( c < 6 )
        {
            if ( l_prayer_times[time_title_array[c]].getTime() < current_time_ms
                 && current_time_ms < l_prayer_times[ time_title_array[ c + 1 ] ].getTime() )
            {
                current_prayer = title_array[c];
            }
        }
        else
        {
            if ( l_prayer_times[time_title_array[c]].getTime() < current_time_ms )
            {
                current_prayer = title_array[c];
            }
        }

        if ( current_prayer )
        {
            var res = new Array();
            res["NAME"] = current_prayer;
            res["JUST_HAPPENED"] = just_happened;
            return res;
        }
    }

    return null;
}

